Subject: Re: i.Mx6Quad - eth0: tx queue full!

From: Troy Kisky <[email-masked]>
Date: Wed, 30 Jan 2013 14:04:36 -0700

On 1/30/2013 8:13 AM, Vikram Narayanan wrote:
> On 1/30/2013 12:16 AM, Troy Kisky wrote:
>> I have fixed this bug (and more) on Freescale's kernel
>> (imx-3.0.35_1.1.0). I created a branch you can try.
>> Feel free to port to mainline.
> Thanks a lot for the branch. I saw a lot of differences between
> your driver and the mainline. I should spend some time If I had
> to port this to mainline.
>   
>> This is the patch that should fix your problem
>> fec: clear TX_FULL in fec_restart
>>
>>
>> Please let me know results.
> When NAPI is disabled I saw a severe packet loss
> (around 40% in a flood ping) which spitted out this,
>
> [  470.390928] net eth0: missed rxf 2000000 1c000000 0
> [  470.419098] net eth0: missed rxf 2000000 1c000000 0
> [  470.443800] net eth0: missed rxf 2000000 1c000000 0
> [  470.450315] net eth0: missed rxf 2000000 1c000000 0
>
> When NAPI is enabled, it was working good. Though it
> resulted in the same error, it recovered by itself,
> which is perfectly fine for me. :)
>

You'll also have better performance if you pass "enable_wait_mode=off" 
in bootargs.